# Function Developer's Guide

Before learning to develop Functions, you should have the client [installed](../installing_cli.md) and a configured provider.

## Tutorial

To learn how to work with functions quickly, have a look at the [developer's tutorial](developers_tutorial.md). This document will guide you through a quick review of prerequisites, and show you how to create, build and deploy your first function project.

## CLI Command Reference

For detailed documentation on the CLI and its commands, please see the [Commands document](commands.md).

## Function Project Configuration

For detailed description of `func.yaml` file that is used for the Function project configuration, please see the [Project Configuration with `func.yaml` document](func_yaml.md).


## Language Guides

* [Golang](golang.md)
* [Node.js](nodejs.md)
* [Python](python.md)
* [Quarkus](quarkus.md)
* [Rust](rust.md)
